import {Injectable} from '@angular/core';
import {HttpClient, HttpParams} from '@angular/common/http';
import {Observable} from 'rxjs';
import {Event} from '../models/event';
import {UtilsService} from './utils.service';
import { environment } from './../../environments/environment';

@Injectable({
	providedIn: 'root'
})
export class ApiService {
	apiUrl = environment.apiUrl + '/calendar/events/';

	constructor(
		private http: HttpClient
	) {
	}

	getEvents(calendar: string): Observable<Event[]> {
		try {
			let password = UtilsService.getPasswordFromLocalStorage();

			let params = new HttpParams();
			params = params.append('password', password);
			return this.http.get<Event[]>((this.apiUrl + calendar + '/json'), {params});
		} catch (exception) {
			console.log('Error fetching events from API');
		}
		return new Observable<Event[]>();
	}

	updateEvent(event: Event): Observable<any> {
		try {
			let password = UtilsService.getPasswordFromLocalStorage();

			let updateEvent: any = event;

			updateEvent.password = password;

			return this.http.put(this.apiUrl + updateEvent.eventId, updateEvent);
		} catch (exception) {
			console.log('Error fetching events from API');
		}
		return new Observable<any>();
	}

	createEvent(event: Event): Observable<any> {
		try {
			let password = UtilsService.getPasswordFromLocalStorage();

			let createEvent: any = event;

			createEvent.password = password;

			return this.http.post(this.apiUrl, createEvent);
		} catch (exception) {
			console.log('Error fetching events from API');
		}
		return new Observable<any>();
	}
}
